#include <math.h>
#include <stdio.h>
#include <string.h>
#include "VI.h"

unsigned short int screenbuffer[320*250];
unsigned short int screenbuffer2[320*250];

inline void * UncachedAddr(void * addr) {
    return (void *)(((unsigned long)addr)|0x20000000);
}

int UltraMain(void) {
   struct VI_config conf,conf2;
   char bob[256];
   int tog=0;
   float offs=0;

   conf.bitdepth=16;
   conf.xres=320;
   conf.yres=250;
   conf.xscale=0.5;
   conf.yscale=0.25;
   conf.framebuffer=UncachedAddr(screenbuffer);
   memcpy(&conf2,&conf,sizeof(conf));
   conf2.framebuffer=UncachedAddr(screenbuffer2);
   VI_WriteRegs(&conf);
   
   while (1) {
        VI_RetraceStartWait();
	(tog?conf.yscale:conf2.yscale)=0.25+cos(offs*M_TWOPI)*0.05;
	(tog?conf.xscale:conf2.xscale)=0.5+sin(offs*M_TWOPI)*0.05;
	VI_WriteRegs(tog?&conf:&conf2);

   	VI_FillScreen(tog?&conf2:&conf,0);

	for (float x=50; x < 270; x+=0.5) {
	    VI_PlotPixel(tog?&conf2:&conf,x,
		    cos(x/320.0*M_TWOPI*4+offs*4)*250.0/4+250/2,0x0700);
	}

	sprintf(bob,"hello world!\n0x%08X\noffs=%.2f",0xdeadbeef,offs);

	VI_PlotText(tog?&conf2:&conf,10,100,bob);

	tog ^= 1;
	offs+=0.05;
   }

   while (1) {}

   return 0;
}
